// Configuration descriptor template
// The device has two interfaces
// - First interface has 2 bulk endpoints
// - Second interface has 1 interrupt IN endpoint

#ifndef __descriptors_h__
#define __descriptors_h__

#include "usb.h"

#define VID_ATMEL 0x03eb 
#define PID_DEBUG 0x0fff

#define VID_SONY 0x12ba
#define PID_GH3  0x0100
#define PID_RB   0x0200

#define PS3_REPORT_SZ 27 // 0x14

#define GUITAR_EP_INT_IN  (1|USB_EP_DIRECTION_IN)
#define GUITAR_EP_INT_OUT (2|USB_EP_DIRECTION_OUT)

typedef struct
{
   S_usb_configuration_descriptor cfg_temp;
   S_usb_interface_descriptor     ifc_temp;
   S_usb_hid_descriptor           hid;
   S_usb_hid_specific_descriptor  hid1;
   S_usb_endpoint_descriptor      ep1_temp;
   S_usb_endpoint_descriptor      ep2_temp;
}S_usb_user_configuration_descriptor;


extern code S_usb_device_qualifier_descriptor desc_dev_qualifier;

extern code char descr_str_langid[];

extern code char descr_str_manuid_rb[];
extern code char descr_str_prodid_rb[];

extern code char descr_str_manuid_gh3[];
extern code char descr_str_prodid_gh3[]; 

extern char code * desc_str_active[];

extern S_usb_device_descriptor code * desc_dev_active;

extern code S_usb_device_descriptor desc_dev_debug;
extern code S_usb_device_descriptor desc_dev_gh3;
extern code S_usb_device_descriptor desc_dev_rb;

extern code U8 sony_hid_report_descriptor[137];
extern U8 sony_hid_report[PS3_REPORT_SZ];

extern S_usb_user_configuration_descriptor code * desc_conf_active;
extern code S_usb_user_configuration_descriptor desc_conf_gh3;
extern code S_usb_user_configuration_descriptor desc_conf_rb;

#endif
