//! @file usb_drv.h,v
//!
//! Copyright (c) 2006 Atmel.
//!
//! Use of this program is subject to Atmel's End User License Agreement.
//! Please read file license.txt for copyright notice.
//!
//! @brief This file contains the USB low level driver definition
//!
//! @version 1.34 at90usb128-demo-template-1_0_5 $Id: usb_peripheral_drv.h,v 1.2 2008-02-29 19:27:52 tyridal Exp $
//!
//! @todo
//! @bug


#ifndef _USB_PERI_DRV_H_
#define _USB_PERI_DRV_H_

//_____ I N C L U D E S ____________________________________________________
#include "compiler.h"


typedef enum endpoint_parameter{ep_num, ep_type, ep_direction, ep_size, ep_bank, nyet_status} t_endpoint_parameter;


#define Is_ep_addr_in(x)         (  (x&0x80)?   TRUE : FALSE)


#define usb_configure_endpoint(num, type, dir, size, bank, nyet)             \
                                    ( Usb_select_endpoint(num),              \
                                      usb_config_ep(Usb_build_ep_config0(type, dir, nyet),\
                                                    Usb_build_ep_config1(size, bank)    ))





//_____ D E C L A R A T I O N ______________________________________________

U8      usb_config_ep                (U8, U8);
U8      usb_select_enpoint_interrupt (void);
U16     usb_get_nb_byte_epw          (void);
U8      usb_send_packet              (U8 , U8*, U8);
U8      usb_read_packet              (U8 , U8*, U8);
void    usb_halt_endpoint            (U8);
void    usb_reset_endpoint           (U8);
U8      usb_init_device              (void);

void usb_peripheral_drv_init(void);
void usb_peripheral_drv_task(void);




#endif  // _USB_DRV_H_

